<?php

declare(strict_types=1);

namespace Drupal\media_iframe_cookie\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\FormatterBase;

/**
 * Plugin implementation of the 'Media Iframe Cookie' formatter.
 *
 * @FieldFormatter(
 *   id = "media_iframe_cookie",
 *   label = @Translation("Media iframe cookie"),
 *   field_types = {"string_long"},
 * )
 */
final class MediaIFrameCookieFormatter extends FormatterBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode): array {
    $element = [];

    // Get render array for each item.
    foreach ($items as $delta => $item) {
      $element[$delta] = [
        '#lazy_builder' => [
          'media_iframe_cookie.external_media_render:getRenderExternalMedia', [
            $item->value, $item->getEntity()->id(),
          ],
        ],
        '#create_placeholder' => TRUE,
      ];
    }

    return $element;
  }

}
